
#include <p30F2012.h>

_FWDT(WDT_OFF);
_FGS(CODE_PROT_OFF);
_FOSC(CSW_FSCM_OFF & FRC_PLL16);
_FBORPOR(PBOR_OFF & PWRT_64 & MCLR_EN);

//----------------------------------------------------------

void sleep(void) {
  unsigned i, j;

  for (i=0; i<15; i=i+1) {
    for (j=0; j<60000;  j=j+1) {
      asm("nop");
    }
  }
}

//----------------------------------------------------------

char rxch;
int  pattern;

void main(void) {

  TRISCbits.TRISC13=1;  // RC13 LED off
  TRISDbits.TRISD8 =1;  // RD8 SW2 input (PROG-RUN)
  TRISDbits.TRISD9 =1;  // RD9 SW1 input

  U1MODE=0x8400;        // alternate I/O (U1ATX/U1ARX), N81
  U1BRG =95;            // 19200bps
  U1STA =0;             // TX disable

  pattern=1;            

  while (1) {
    U1STAbits.OERR=0;                    // clear overrun error
    if (U1STAbits.URXDA!=00) {           // if incoming character exists
      rxch=U1RXREG;                      // then receive character
    }
    if (('0'<=rxch)&&(rxch<='5')) {      // '0'<=rxch<='5'
      pattern=rxch-'0';                  // 0<=pattern<=5
    } else if ((PORTDbits.RD8==0)&&(PORTDbits.RD9==0)) {
      pattern=1;
    } else if ((PORTDbits.RD8==1)&&(PORTDbits.RD9==0)) {
      pattern=2;
    } else if ((PORTDbits.RD8==0)&&(PORTDbits.RD9==1)) {
      pattern=3;
    } else if ((PORTDbits.RD8==1)&&(PORTDbits.RD9==1)) {
      pattern=4;
    }    
    TRISCbits.TRISC13=0;                 // LED on
    switch (pattern) {
      case 0 : 
        TRISCbits.TRISC13=1;             // LED off
        sleep();
        break;
      case 1 :
        PORTCbits.RC13=0;                // GREEN
        sleep();
        TRISCbits.TRISC13=1;             // LED off 
        sleep();
        break;
      case 2 :
        PORTCbits.RC13=1;                // RED
        sleep();
        TRISCbits.TRISC13=1;             // LED off
        sleep();
        break;
      case 3 :
        PORTCbits.RC13=0;                // GREEN
        sleep();
        break;
      case 4 :
        PORTCbits.RC13=1;                // RED
        sleep();
        break;
      case 5 :
        PORTCbits.RC13=~PORTCbits.RC13;  // RED/GREEN blink
        sleep();
        break;
    }
  }

}
