// RS-232C loopback test                           
//   19200bps, data=8bit, stop bit=1bit, non parity, no flow control   

#include <p30f2012.h>

volatile unsigned data;

void __attribute__ ((__interrupt__)) _AltU1RXInterrupt(void) {
  U1RXREG;                            // dummy read
  data=(data+32)%64;                  // toggle upper/lower case
  PORTCbits.RC13=~PORTCbits.RC13;     // toggle RC13 output (LED) 
  IFS0bits.U1RXIF=0;                  // clear interrupt flag
}

//---------------------------------------------------------------------

int main(void) {
  unsigned i, j;

  data=0;                             // initialize TX data

  TRISCbits.TRISC13=0;                // RC13 is output 

  U1MODE=0x8000;                      // use U1TX(UTX) 
  U1BRG =95;                          // 19200bps (29.48MHz/16/19200-1=95)
  U1STA =0x0400;                      // start transmission (UTXEN=1)

  INTCON1=0x0000;                     // nothing to set values
  INTCON2bits.ALTIVT=1;               // use AIVT (Alternate IVT)
  IFS0=0x0000;                        // clear all interrupt
  IEC0bits.U1RXIE=1;                  // enable U1RX Interrupt 

  while (1) {                         // foreber loop
    if (U1STAbits.UTXBF!=1) {         // if TX buffer is not full
      U1TXREG=data+64;                // send data
      data=(data+1)%64;               // increment data
    }
    for (i=0; i<10000; i=i+1) {       // wait....
      for (j=0; j<100; j=j+1) {
        ;
      }
    }
  }

}
