// color LED driver
// output pin = RB6, RB7, RB8

#include <p30f2012.h>     // include dsPIC30F2012 header file
#include <stdlib.h>       // for rand() function

//===============================================================
void delay1ms(unsigned t) {
  unsigned i, j;

  for (i=0; i<t; i=i+1) {
    for (j=0; j<10; j=j+1) {
      asm("repeat #2900");  // for 29.48MHz clock
      asm("nop");
    }
  }  
}

//===============================================================

int main(void) {
  unsigned pattern, last_pattern;

  //ADPCFG=0xffff;                    // disable all A/D input pin

  TRISBbits.TRISB6=0;                 // RB6 is output  
  TRISBbits.TRISB7=0;                 // RB7 is output
  TRISBbits.TRISB8=0;                 // RB8 is output

  pattern=0;
  while(1) {                   
    delay1ms(1000);                   // 1000ms delay
    do {
      last_pattern=pattern;           // save last pattern
      pattern=rand()%7;               // pattern=0-7
    } while(last_pattern==pattern);   // should generate new pattern
    PORTB=pattern<<6;                 // update RB6-RB8
  }

}
